// cc-by 3.0 Austria, (c) 2010 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/

println(" function");

function add(a : Number, b : Number) : Number {
    return a + b;
}

var x = add(1, 2);
println(x);


println("\n bind function");

var a = 1;
var b = 2;

var x2 = bind add(a + 5, b * 3);
println(x2);

a = 2;
println(x2);

b = 3;
println(x2);


println("\n function parameters");

function mul(a : Number, b : Number) : Number {
    return a * b;
}

function binToUnaryFunc(binFunc : function (:Number,:Number):Number) : function (:Number):Number {
    return function(x : Number) { return binFunc(x, x); }
}

var unaryAdd = binToUnaryFunc(add);
println(unaryAdd(3));
println(unaryAdd(5));

var unaryMul = binToUnaryFunc(mul);
println(unaryMul(3));
println(unaryMul(5));
